(text "{% extends \"auth/base.html\" %} {% block head %}")
(title
    (text "Connection"))

(text "{% endblock %} {% block title %}Connection{% endblock %} {% block content %}")
(div
    ("class" "w-full flex-col gap-2")
    ("id" "status")
    ; display loading text because we have to wait for the data to update on remote
    (b
        (text "Working...")))

(text "{% if connection_type == \"Spotify\" and user and user.connections.Spotify and config.connections.spotify_client_id %}")
(script
    (text "setTimeout(async () => {
        const code = new URLSearchParams(window.location.search).get(\"code\");
        const client_id = \"{{ config.connections.spotify_client_id }}\";
        const verifier = \"{{ user.connections.Spotify[0].data.verifier }}\";

        if (!code) {
            alert(\"Connection failed (did not get code from Spotify)\");
            return;
        }

        const [token, refresh_token, expires_in] = await trigger(
            \"spotify::get_token\",
            [client_id, verifier, code],
        );

        const profile = await trigger(\"spotify::profile\", [token]);

        const { message } = await trigger(\"connections::push_con_data\", [
            \"Spotify\",
            {
                token,
                refresh_token,
                expires_in: expires_in.toString(),
                name: profile.display_name,
                url: profile.external_urls.spotify,
            },
        ]);

        document.getElementById(\"status\").innerHTML =
            `<b>${message}.</b> You can now close this tab.`;

        setTimeout(() => {
            window.location.href = \"/settings#/connections\";
        }, 500);
    }, 150);"))

(text "{% elif connection_type == \"LastFm\" and user and user.connections.LastFm and config.connections.last_fm_key %}")
(script
    (text "setTimeout(async () => {
        const token = new URLSearchParams(window.location.search).get(\"token\");
        const api_key = \"{{ config.connections.last_fm_key }}\";

        if (!token) {
            alert(\"Connection failed (did not get token from Last.fm)\");
            return;
        }

        const res = await trigger(\"last_fm::get_session\", [token]);
        const { message } = await trigger(\"connections::push_con_data\", [
            \"LastFm\",
            {
                session_token: res.session.key,
                name: res.session.name,
                url: `https://last.fm/user/${res.session.name}`,
            },
        ]);

        document.getElementById(\"status\").innerHTML =
            `<b>${message}.</b> You can now close this tab.`;

        setTimeout(() => {
            window.location.href = \"/settings#/connections\";
        }, 500);
    }, 1000);"))

(text "{%- endif %} {% endblock %}")
