(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "Question - {{ config.name }}"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    ("class" "flex flex-col gap-2")
    (div
        ("style" "display: contents")
        (text "{{ components::question(question=question, owner=owner) }}"))
    (text "{% if user and (user.id == question.receiver or question.is_global) and not has_answered %}")
    (div
        ("class" "card-nest")
        (div
            ("class" "card small flex items-center gap-2")
            (text "{{ icon \"square-pen\" }}")
            (b
                (text "{{ text \"requests:label.answer\" }}")))
        (form
            ("class" "card flex flex-col gap-2")
            ("onsubmit" "answer_question_from_form(event, '{{ question.id }}')")
            (div
                ("class" "flex flex-col gap-1")
                (label
                    ("for" "content")
                    (text "{{ text \"communities:label.content\" }}"))
                (textarea
                    ("type" "text")
                    ("name" "content")
                    ("id" "content")
                    ("placeholder" "content")
                    ("required" "")
                    ("minlength" "2")
                    ("maxlength" "4096")))
            (div
                ("id" "files_list")
                ("class" "flex gap-2 flex-wrap"))
            (div
                ("class" "flex gap-2")
                (text "{{ components::emoji_picker(element_id=\"content\", render_dialog=true) }} {% if is_supporter -%} {{ components::file_picker(files_list_id=\"files_list\") }} {% endif %}")
                (button
                    ("class" "primary")
                    (text "{{ text \"requests:label.answer\" }}")))))
    (text "{%- endif %}")
    (div
        ("class" "card-nest w-full")
        ("data-tab" "replies")
        (div
            ("class" "card small flex items-center gap-2")
            (text "{{ icon \"newspaper\" }}")
            (span
                (text "{{ text \"communities:label.replies\" }}")))
        (div
            ("class" "card flex flex-col gap-4")
            (text "{% for post in replies %} {{ components::post(post=post[0], owner=post[1], question=false, secondary=true, show_community=false) }} {% endfor %}  {{ components::pagination(page=page, items=replies|length) }}"))))

(script
    (text "const community = \"{{ question.community }}\";
    window.answer_question_from_form = async (e, answering) => {
        e.preventDefault();
        await trigger(\"atto::debounce\", [\"posts::create\"]);

        // poll
        const poll_data = [true, null];

        // create body
        const body = new FormData();

        if (e.target.file_picker) {
            for (const file of e.target.file_picker.files) {
                body.append(file.name, file);
            }
        }

        body.append(
            \"body\",
            JSON.stringify({
                content: e.target.content.value,
                community: community ? community : \"{{ config.town_square }}\",
                answering,
                poll: poll_data[1],
            }),
        );

        // ...
        fetch(\"/api/v1/posts\", {
            method: \"POST\",
            body,
        })
            .then((res) => res.json())
            .then((res) => {
                trigger(\"atto::toast\", [
                    res.ok ? \"success\" : \"error\",
                    res.message,
                ]);

                if (res.ok) {
                    window.location.reload();
                }
            });
    };"))

(text "{% endblock %}")
