(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "IP Bans - {{ config.name }}"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    ("class" "flex flex-col gap-2")
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (div
                ("class" "flex items-center gap-2")
                (text "{{ icon \"ban\" }}")
                (span
                    (text "{{ text \"general:link.ip_bans\" }}")))
            (button
                ("onclick" "prompt_ban_ip()")
                ("class" "quaternary small")
                (text "{{ icon \"plus\" }}")
                (span
                    (text "{{ text \"communities:action.create\" }}"))))
        (div
            ("class" "card flex flex-col gap-2")
            (text "{% for item in items %}")
            (div
                ("class" "card-nest")
                (a
                    ("class" "card small flex items-center gap-2 flush")
                    ("href" "/api/v1/auth/user/find/{{ item.moderator }}")
                    (text "{{ components::avatar(username=item.moderator, selector_type=\"id\") }}")
                    (span
                        (text "{{ item.moderator }}"))
                    (span
                        ("class" "fade date")
                        (text "{{ item.created }}")))
                (div
                    ("class" "card secondary flex flex-col gap-2")
                    (code
                        (text "{{ item.ip }}"))
                    (span
                        (text "{{ item.reason|markdown|safe }}"))
                    (div
                        ("class" "card w-full flex flex-wrap gap-2")
                        (button
                            ("onclick" "remove_ipban('{{ item.ip }}')")
                            ("class" "red quaternary")
                            (text "{{ icon \"trash\" }}")
                            (span
                                (text "{{ text \"general:action.delete\" }}"))))))
            (text "{% endfor %}")
            (text "{{ components::pagination(page=page, items=items|length) }}"))))

(script
    (text "async function prompt_ban_ip() {
        const ip = await trigger(\"atto::prompt\", [\"IP address (or prefix):\"]);

        if (!ip) {
            return;
        }

        trigger(\"atto::ban_ip\", [ip]);
    }

    async function remove_ipban(ip) {
        if (
            !(await trigger(\"atto::confirm\", [
                \"Are you sure you would like to do this?\",
            ]))
        ) {
            return;
        }

        fetch(`/api/v1/bans/${ip}`, {
            method: \"DELETE\",
        })
            .then((res) => res.json())
            .then((res) => {
                trigger(\"atto::toast\", [
                    res.ok ? \"success\" : \"error\",
                    res.message,
                ]);
            });
    }"))

(text "{% endblock %}")
